/* $Id: classes.h,v 1.1.1.1 1992/03/18 09:04:11 uep Exp $ */
/*****************************************************************************
MODULE:  Go Editor
FILE:    classes.h
AUTHOR:  Aline Jacomet
DATE:    May 31th 1991

DESCRIPTION:
    class definitions

COPYRIGHT:
  Copyright (c) 1990, 1991 Bull S.A., Paris, France

  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull.

  The permission to distribute or sublicense FOR CHARGE either this software
  (all or part) or products derived from this software is subject to prior
  licence from Bull under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull.

  Bull assumes no responsibility for the use or inability to use any of its
  software. The software is provided "AS IS" without warranty of any
  kind, and Bull expressly disclaims all implied warranties, including
  but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull be liable for any special, incidental, indirect
  or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.
******************************************************************************/
#ifndef _classes_h
#define _classes_h


#include <sys/types.h>
#include <stdlib.h>
#include "common.h"

#include <Go/Tools/Rgb.h>



class PenAttributes {
  public:
    char* PenText;
    char* Color;
    GRgb  Rgb_Color;
    char* AltColor;
    GRgb  Rgb_AltColor;
    int   LineStyle;
    char* LineWidth;
    int   CapStyle;
    int   JoinStyle;

    PenAttributes();
    ~PenAttributes();

    void operator = (const PenAttributes&);
    unsigned char operator != (const PenAttributes&);
};


class BrushAttributes {
  public:
    char* BrushText;
    char* Color;
    GRgb  Rgb_Color;
    int   FillRule;

    BrushAttributes();
    ~BrushAttributes();

    void operator = (const BrushAttributes&);
    unsigned char operator != (const BrushAttributes&);
};


class TextAttributes {
  public:
    char* TextBrushText;
    char* Color;
    GRgb  Rgb_Color;
    char* Font; 

    TextAttributes();
    ~TextAttributes();

    void operator = (const TextAttributes&);
    unsigned char operator != (const TextAttributes&);
};


class AllAttributes {
  public:
    unsigned char BackgroundIsSet;
    unsigned char OutlineIsSet;
    unsigned char RoundedIsSet;
    char*         PenText;
    char*         BrushText;
    char*         TextBrushText;

    PenAttributes   pen;
    BrushAttributes brush;
    TextAttributes  text;

    AllAttributes();
    ~AllAttributes();
};


#endif /* _classes_h */
