/* $Id: common.h,v 1.4 1992/12/30 12:36:44 jacomet Exp $ */
/*****************************************************************************
MODULE:  Go Editor
FILE:    common.h
AUTHOR:  Aline Jacomet
DATE:    May 21th 1991

DESCRIPTION:
    

COPYRIGHT:
  Copyright (c) 1990, 1991 Bull S.A., Paris, France

  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull.

  The permission to distribute or sublicense FOR CHARGE either this software
  (all or part) or products derived from this software is subject to prior
  licence from Bull under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull.

  Bull assumes no responsibility for the use or inability to use any of its
  software. The software is provided "AS IS" without warranty of any
  kind, and Bull expressly disclaims all implied warranties, including
  but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull be liable for any special, incidental, indirect
  or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.
******************************************************************************/
#ifndef _common_h
#define _common_h


#include <stdio.h>



                               /***********
				* DEFINES *
				***********/

#define max(a,b) (((a) > (b)) ? (a) : (b))

#define UNNAMED "unnamed"


#define CURRENT     0
#define MODIFY      1
#define FAST_MODIFY 2

#define EDIT   0
#define NAMED  1
#define MAIN   2


#define PEN       0x0001
#define BRUSH     0x0002
#define TEXTBRUSH 0x0004
#define NONE      0x0008


#define PEN_COLOR       0
#define PEN_ALT_COLOR   1
#define BRUSH_COLOR     2
#define TEXT_COLOR      3


#define LINESOLID  0
#define LINEONOFF  1
#define LINEDOUBLE 2

#define CAPBUTT    1
#define CAPROUND   2
#define CAPPROJECT 3

#define JOINMITER  0
#define JOINROUND  1
#define JOINBEVEL  2

#define EVENODDRULE  0
#define WINDINGRULE  1

#define ALIGN_TOP         0
#define ALIGN_BOTTOM      1
#define ALIGN_RIGHT       2
#define ALIGN_LEFT        3
#define ALIGN_VERTICAL    4
#define ALIGN_HORIZONTAL  5
#define ALIGN_TOP_BOTTOM  6
#define ALIGN_BOTTOM_TOP  7
#define ALIGN_LEFT_RIGHT  8
#define ALIGN_RIGHT_LEFT  9

#define SPACING_X  0
#define SPACING_Y  1

#define ROTATE_45   0
#define ROTATE_90   1
#define ROTATE_135  2
#define ROTATE_180  3
#define ROTATE_225  4
#define ROTATE_270  5
#define ROTATE_315  6

#define MIRROR_I   0
#define MIRROR_J   1
#define MIRROR_IJ  2

#define A5               0
#define A4               1
#define A3               2
#define LETTER           3
#define B5               4
#define B4               5
#define AUTOMATIC_RESIZE 6
#define DEFAULT_FORMAT   1

#define PORTRAIT            0
#define LANDSCAPE           1
#define DEFAULT_ORIENTATION 1

#define ARC_FILE            "arc."
#define CIRCLE_FILE         "circle." 
#define BEZIER_FILE         "bezier."
#define BCARDINAL_FILE      "bcardinal."
#define BETATAU_FILE        "betatau."
#define ELLIPSE_FILE        "ellipse."
#define IMAGE_FILE          "image."
#define POLYGON_FILE        "polygon."
#define POLYLINE_FILE       "polyline."
#define RECTANGLE_FILE      "rectangle."
#define REGPOLYGON_FILE     "reg-poly."
#define TEXT_FILE           "text."
#define MCTEXT_FILE         "mctext."
#define LABEL_FILE          "label."
#define SCROLLTEXT_FILE     "scroll-text."
#define ARC_ELLIPSE_CR_FILE "arc-ell-cr."
#define ARC_CIRCLE_CR_FILE  "arc-circ-cr."
#define CIRCLE_CR_FILE      "circle-cr." 
#define CURVE_CR_FILE       "curves-cr."
#define ELLIPSE_CR_FILE     "ellipse-cr."
#define HAND_CR_FILE        "hand-cr."
#define IMAGE_CR_FILE       "image-cr."
#define POLYGON_CR_FILE     "polygon-cr."
#define POLYLINE_CR_FILE    "polylin-cr."
#define RECTANGLE_CR_FILE   "rect-cr."
#define REGPOLYGON_CR_FILE  "reg-pol-cr."
#define SQUARE_CR_FILE      "square-cr."
#define TEXT_CR_FILE        "texts-cr."
#define FILE_FILE           "file."
#define EDIT_FILE           "edit."
#define STRUCTURE_FILE      "structure."
#define SELECTION_FILE      "selection."
#define ATTRIBUTES_FILE     "attrib."
#define NAM_ATTRIBUTES_FILE "nam-attrib."
#define VIEW_FILE           "view."
#define MISCEL_FILE         "miscel."
#define HELP_FILE           "help."
#define HELP_INDEX_FILE	    "index."
#define HELP_OVERVIEW_FILE  "overview."
#define HELP_KEYBOARD_FILE  "keyboard."
#define HELP_GODRAW_FILE    "godraw."
#define HELP_GOINFO_FILE    "goinfo."
#define EDIT_ATTRIB_FILE    "edit-attrib."
#define NAMED_ATTRIB_FILE   "named-attrib."
#define ALL_ATTRIB_FILE     "all-attrib."
#define PEN_ATTRIB_FILE     "pen-attrib."
#define BRUSH_ATTRIB_FILE   "brush-attrib."
#define TEXT_ATTRIB_FILE    "text-attrib."


#define NAMED_OBJECTS_FILE  "named-obj.str"




                               /***********
				* WIDGETS *
				***********/

extern void* main_window;
extern void* graphic;
extern void* help_graphic;

                              /**********
			       * OTHERS *
			       **********/

extern float pixel_size;
extern int   WhichColor;
extern int   WhichAttributes;
extern char* font_name;


#endif /* _common_h */
