# $Id: mklk.sh,v 1.1.1.1 1992/03/18 09:34:24 uep Exp $
# mklk (Make hard links)
#   makes the directory hierarchy from $1 to $2 by
#   making (hard) links between files except: Makefiles, Site.def, *.o and *.a
#
#   copying Site.def into DstDir/config (if not exists)

if [ $# != 2 ]
   then echo "usage: mklk srcdir dstdir" 
        exit 1
fi

CurrentDir=`pwd`
cd $2; DstDir=`pwd`
cd $CurrentDir; cd $1; SrcDir=`pwd`


echo "Making hard links FROM $SrcDir TO $DstDir (y|n)? \c"
read YorN
if [ $YorN != "y" ]
   then exit 0
fi

echo "Linking files ..."
cd $SrcDir
find . ! \( -name Makefile -o \
	    -name Site.def -o \
	    -name *.log    -o \
	    -name *.o      -o \
	    -name *.a         \) -print \
	| sed '/CVS.adm/d' | cpio -plmdvu $DstDir 2>$DstDir/mklk.log 1>&2

echo "Copying Site.def in $DstDir/config (if not exists)"
if [ ! -f $DstDir/config/Site.def ]; then
    cp $SrcDir/config/Site.def $DstDir/config/Site.def
fi

echo "*** New Go hierarchy ($DstDir) done ***"
