# $Id: mkls.sh,v 1.1.1.1 1992/03/18 09:34:28 uep Exp $
# mkls (Make symbolic links)
#   makes the directory hierarchy from $1 to $2 by
#   making symbolic links between files except: Makefiles, Site.def, *.o and *.a
#
#   copying Site.def into DstDir/config (if not exists)

if [ $# != 2 ]
   then echo "usage: mkls srcdir dstdir"
        exit 1
fi

CurrentDir=`pwd`
cd $2; DstDir=`pwd`
cd $CurrentDir; cd $1; SrcDir=`pwd`


echo "Making symbolic links FROM $SrcDir TO $DstDir (y|n)? \c"
read YorN
if [ $YorN != "y" ]
   then exit 0
fi

echo "Creating directories ..."
cd $SrcDir
find . -type d ! \( -name CVS.adm \) -print | cpio -pmdv $DstDir >$DstDir/mkls.log 2>&1

echo "Linking files ..."
ls -a | while read dir; do
    if [ -d $dir -a $dir != .. ]; then
	find $dir ! \( -name Makefile -o \
		       -name Site.def -o \
		       -name *.log    -o \
		       -name *.o      -o \
		       -name *.a	 \) -print | sed '/CVS.adm/d' |
		while read file; do
		    if [ -f $file ]; then
			/bin/rm -f $DstDir/$file
			ln -s $SrcDir/$file $DstDir/$file 2>>$DstDir/mkls.log 1>&2
		    fi
		done
    fi
done

echo "Copying Site.def in $DstDir/config (if not exists)"
if [ ! -f $DstDir/config/Site.def ]; then
    cp $SrcDir/config/Site.def $DstDir/config/Site.def
fi

echo "*** New Go hierarchy ($DstDir) done ***"

