/* $Id: EdHandPLine.h,v 1.2 1992/12/29 08:39:31 smadja Exp $ */
/*****************************************************************************
MODULE:  BGo  (User Interface)
FILE:    EdHandPLine.h
AUTHOR:  Philippe Smadja
DATE:    July 92

DESCRIPTION:

  Edit a polyline free hand.
  Subclas of geometric: program name: "GoPolyline.handEdit"
  
	 
COPYRIGHT:
  Copyright (c) 1990, 1991, 1992 Bull S.A., Paris, France
 
  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull.
  
  The permission to distribute or sublicense FOR CHARGE either this software

  (all or part) or products derived from this software is subject to prior
  licence from Bull under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull.

  Bull assumes no responsibility for the use or inability to use any of its
  software. The software is provided "AS IS" without warranty of any
  kind, and Bull expressly disclaims all implied warranties, including
  but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull be liable for any special, incidental, indirect
  or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.

*****************************************************************************/
#ifndef _GEdHandPLine_H
#define _GEdHandPLine_H

#include <Go/EdGeometric.h>
#include <Go/Event.h>
#include <Go/Tools/GCdef.h>
#include <Go/Tools/Point.h>
#include <Go/Tools/CoordSys.h>
#include <Go/Tools/Array.h>
#include <Go/Tools/Pen.h>


/**
  *-------------------------------------------------------
  * The GEditHandPolylinePgm class.
  *-------------------------------------------------------
  */

class GEditHandPolylinePgm : public GEditGeometricPgm
{
  public:
    static GEditHandPolylinePgm* create (); 

    // superclasses virtual method;
    virtual GInteractor* start (const GEvent*, Go*);

  protected:
    GEditHandPolylinePgm (const char*);
};

class GoPolyline;
class GEvent;

/*
 *-------------------------------------------------------
 * The GEditHandPolyline class:
 * IT IMPLEMENTS only edition of a polyline.
 *-------------------------------------------------------
 */

class GEditHandPolyline : public GEditGeometric
{
  public:

    GEditHandPolyline (GEditGeometricPgm*, const GEvent*, GoPolyline*);

    virtual ~GEditHandPolyline ();

    virtual void  draw();
    virtual void  drawAll();
    virtual void  clear();
    virtual void  clearAll();
    virtual void  compute (const GEvent*);  // superclass first;
    virtual void  doit ();
    
  protected:
    virtual void  Initialize ();        //  super class last;
    
  private:
    GBool     _newPoint;
    int       _index;     // index for point  which follows the mouse;
    GArray    _pts;
};

#endif /* _GEdHandPLine_H */
