/* $Id: EdPolygon.h,v 1.2 1992/12/24 10:31:46 smadja Exp $ */
/*****************************************************************************
MODULE:  BGo  (User Interface)
FILE:    EdPolygon.h
AUTHOR:  Philippe Smadja
DATE:    July 92

DESCRIPTION:

  GEditPolygon is a subclass of GEditPolyline
   	 
COPYRIGHT:
  Copyright (c) 1990, 1991, 1992 Bull S.A., Paris, France
 
  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull.
  
  The permission to distribute or sublicense FOR CHARGE either this software

  (all or part) or products derived from this software is subject to prior
  licence from Bull under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull.

  Bull assumes no responsibility for the use or inability to use any of its
  software. The software is provided "AS IS" without warranty of any
  kind, and Bull expressly disclaims all implied warranties, including
  but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull be liable for any special, incidental, indirect
  or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.

*****************************************************************************/
#ifndef _GEdPolygon_H
#define _GEdPolygon_H

#include <Go/EdPolyline.h>

class GoPolygon;
class GEvent;

/*
  *-------------------------------------------------------
  * The GEditPolygonPgm class
  *-------------------------------------------------------
  */

class GEditPolygonPgm : public GEditPolylinePgm
{
  public:
    static GEditPolygonPgm* create (); 

    // superclasses virtual method;
    virtual GInteractor* start (const GEvent*, Go*);
    
  protected:
    GEditPolygonPgm (const char*);
};


/*
  *-------------------------------------------------------
  * The GMovePolygonPgm class
  *-------------------------------------------------------
  */

class GMovePolygonPgm : public GMovePolylinePgm
{
  public:
    static GMovePolygonPgm* create (); 

    // superclasses virtual method;
    virtual GInteractor* start (const GEvent*, Go*);
    
  protected:
    GMovePolygonPgm (const char*);
};


/*
 *-------------------------------------------------------
 * The GEditPolygon class (subclass of GEditPolyline)
 * This class implements the draw()/drawAll()
 * Remember that GEditPolyline implements both MOVE and EDIT.
 *-------------------------------------------------------
 */

class GEditPolygon : public GEditPolyline
{
  public:

    GEditPolygon (GEditGeometricPgm*, const GEvent*, GoPolygon*,
		  int mode, GButton addpointbutton_if_move_is_false);
    virtual ~GEditPolygon ();
    virtual void  draw ();
    virtual void  drawAll ();
    virtual void  clear ();
    virtual void  clearAll ();

  protected:
    void DrawLastLine();
};

    
#endif /* _GEdPolygon_H */


