/* $Id: Converter.h,v 1.5 1992/12/14 09:22:38 jacomet Exp $ */
/*****************************************************************************
MODULE:  Data Conversion
FILE:    Converter.h
AUTHOR:  Aline Jacomet
DATE:    March 1992

DESCRIPTION:
  See Reference Manual.
  

COPYRIGHT:
  Copyright (c) 1990, 1991 Bull S.A., Paris, France

  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull.

  The permission to distribute or sublicense FOR CHARGE either this software
  (all or part) or products derived from this software is subject to prior
  licence from Bull under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull.

  Bull assumes no responsibility for the use or inability to use any of its
  software. The software is provided "AS IS" without warranty of any
  kind, and Bull expressly disclaims all implied warranties, including
  but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull be liable for any special, incidental, indirect
  or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.
******************************************************************************/
#ifndef _Converter_h
#define _Converter_h

#include <string.h>
#include <Go/Tools/Set.h>
#include <Go/Ext/ExtDefs.h>


class GConverter
{
  public:
    GConverter();
    ~GConverter();
    
    char* goToGostream(const GSet* go, ulong& size,
		       GStreamType type=GBINARY_STREAM,
		       char* header=NULL) const;
    ushort goToGostreamFile(const GSet* go, const char* filename,
			    GStreamType type=GBINARY_STREAM,
			    char* header=NULL) const;
    char* sharedToGostream(const GSet* sh, ulong& size,
			   GStreamType type=GBINARY_STREAM,
			   char* header=NULL) const;
    ushort sharedToGostreamFile(const GSet* sh, const char* filename,
				GStreamType type=GBINARY_STREAM,
				char* header=NULL) const;
    ushort gostreamToGo(const char* stream, ulong size, GSet* gos,
			uint& nb_gos, GSet* shared, uint& nb_shared,
			char** header=NULL) const;
    ushort gostreamFileToGo(const char* filename, GSet* gos, uint& nb_gos,
			    GSet* shared, uint& nb_shared,
			    char** header=NULL) const;
    ushort streamToFile(const char* stream, const ulong size,
			const char* filename) const;
    char* fileToStream(const char* filename, ulong& size) const;

  protected:
    ushort verify_filename(const char* filename) const;

  private:
    GBool dummy;   // some compilers don't like classes without datas;
};

    
#endif /* _Converter_h */
