/* $Id: ExtDefs.h,v 1.1 1992/12/14 09:27:08 jacomet Exp $ */
/*****************************************************************************
MODULE:  Extensions
FILE:    ExtDefs.h
AUTHOR:  Aline Jacomet
DATE:    December 1992

DESCRIPTION:
    Contains all defines used by the extensions. These defines are returned
    by methods.

COPYRIGHT:
  Copyright (c) 1990, 1991 Bull S.A., Paris, France

  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull.

  The permission to distribute or sublicense FOR CHARGE either this software
  (all or part) or products derived from this software is subject to prior
  licence from Bull under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull.

  Bull assumes no responsibility for the use or inability to use any of its
  software. The software is provided "AS IS" without warranty of any
  kind, and Bull expressly disclaims all implied warranties, including
  but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull be liable for any special, incidental, indirect
  or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.
******************************************************************************/
#ifndef ExtDefs_h
#define ExtDefs_h


/*
 * For many classes
 */
#define GERROR 0


/*
 * File errors
 */
#define GIS_NOT_REG_FILE   1
#define GFILE_ACCESS_ERROR 2
#define GFILE_EXIST        3
#define GNO_FILE           4


/*
 * For Clipboard;
 */
typedef enum {
    GCONVERSION_ERROR = 5,
    GCOMMUNICATION_ERROR,
    GFORMAT_ERROR,
    GNO_ERROR
} GClipboardError;


/*
 * For many classes
 */
#define GNOT_IMPLEMENTED 9


/*
 * For Editor
 */
#define GLOAD_STREAM_ERROR        10
#define GSAVE_STREAM_ERROR        11
#define GNO_UNDO                  12
#define GNO_REDO                  13
#define GONE_OR_MORE_OBJECT       14
#define GTWO_OR_MORE_OBJECT       15
#define GNONE_OR_ONE_OBJECT       16
#define GONE_OBJECT               17
#define GNO_PRINTER               18
#define GNO_OBJECT                19

/*
 * For MultiPage Editor
 */
#define GNO_NEXT_PAGE      20
#define GNO_PREVIOUS_PAGE  21
#define GNO_INDICATED_PAGE 22

/*
 * For many classes;
 */

#define GOK          23
#define GUSER_CANCEL 24

#define GNEXT_ERROR  30

/*
 * editor questions
 */
#define GQ_OVERWRITE_FILE      0
#define GQ_OVERWRITE_ASSOC     1
#define GQ_DESTROY_ALL_OBJECTS 2
#define GQ_QUIT                3
#define GQ_CLOSE               4

#define GNEXT_QUESTION         8


/*
 * For Converter and Editor;
 */
typedef enum {
    GBINARY_STREAM,
    GASCII_STREAM
} GStreamType;

#endif /* ExtDefs_h */
