/* $Id: FullSensor.h,v 1.1 1992/12/10 15:37:31 jojic Exp $ */
/*****************************************************************************
MODULE: Graphic Objects
FILE:   FullSensor.h
AUTHOR: jojic
DATE:   Jul 28 1992

DESCRIPTION :
  
COPYRIGHT :    
  Copyright (c) 1992 Bull S.A.
 
  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull S.A. may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull S.A..
  
  The permission to distribute or sublicense FOR CHARGE either this software
  (all or part) or products derived from this software is subject to prior
  licence from Bull S.A. under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull S.A..

  Bull S.A. assumes no responsibility for the use or inability to use
  any of its software. The software is provided "AS IS" without warranty
  of any kind, and Bull S.A. expressly disclaims all implied warranties,
  including but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull S.A. be liable for any special, incidental,
  indirect or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.
*****************************************************************************/
#ifndef _FullSensor_h
#define _FullSensor_h

#include <Go/Sensor.h>

class GoFullSensorMetaclass;


/*
 *----------------------
 * The GoFullSensor class
 *----------------------
 */

class GoFullSensor : public GoSensor
{
  public:

    /* mandatory static methods: */

    static GoFullSensorMetaclass* metaclass();
    static GoFullSensor* create ();
    static GoFullSensor* create
	(const char* name, Go* parent, const GEvent* start_event = NULL,
	 void (*)(void* cl, GoSensor*) = NULL, void* closure = NULL);

    static int save (const GoFullSensor*, GoStream*);
    static int restore (GoFullSensor**, GoStream*);   // creates + restores;
    static int readParams (GoFullSensor*, GoStream*); // restores only;


  protected:

    /* specific protected methods */

    GoFullSensor ();

    /* mandatory protected virtual methods: */

    ~GoFullSensor ();
    virtual GBool m_contains (const GPoint&, GNumber = 0) const;
    virtual void m_dup (const Go*, Go*, Go*, GBool, GBool);

  private:

    /* specific private methods: */


    /* mandatory private virtual methods */

    virtual GoMetaclass* m_metaclass() const;

    /* friends: */

    friend class GoFullSensorMetaclass;
};



/*
 *-------------------------------
 * The GoFullSensorMetaclass class
 *-------------------------------
 */

class GoFullSensorMetaclass : public GoSensorMetaclass
{
  public:
    /* pre- and post- conditions: */

  protected:

             GoFullSensorMetaclass ();  //to get the GoFullSensorMetaclass use:
    virtual ~GoFullSensorMetaclass ();  //        GoFullSensor::metaclass()

  private:

    /* mandatory private virtual methods: */

    virtual const char*       m_classname () const;
    virtual GoMetaclass*      m_superclass () const;
    virtual const GActionRec* m_actions () const;
    virtual Go*               m_create () const;

    /* private data */

    /* friends */

    friend class GoFullSensor;
};



/*
 *----------------
 * inline methods
 *----------------
 */


inline GoFullSensor* GoFullSensor::create ()
{
    return (GoFullSensor*) Go::Create(GoFullSensor::metaclass());
}

#endif /* _FullSensor_h */
