/* $Id: GraphDef.h,v 1.1.1.1 1992/03/18 09:52:13 uep Exp $ */
/*****************************************************************************
MODULE:  BULL Graphic Objects
FILE:    GraphDef.h
AUTHOR:  Aline Jacomet
DATE:    January 11th 1991

DESCRIPTION:
         Some definitions.

COPYRIGHT:
  Copyright (c) 1990, 1991 Bull S.A., Paris, France
 
  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull.
  
  The permission to distribute or sublicense FOR CHARGE either this software
  (all or part) or products derived from this software is subject to prior
  licence from Bull under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull.

  Bull assumes no responsibility for the use or inability to use any of its
  software. The software is provided "AS IS" without warranty of any
  kind, and Bull expressly disclaims all implied warranties, including
  but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull be liable for any special, incidental, indirect
  or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.
******************************************************************************/
#ifndef _GoGraDef_h
#define _GoGraDef_h



/*
 * position types definition
 */
#define GLEFT_TO_RIGHT       0
#define GRIGHT_TO_LEFT       1
#define GUP_TO_BOTTOM        2
#define GBOTTOM_TO_UP        3
#define GAPPLICATION_DEFINE  4


/*
 * anchoring types definition
 */
#define GCENTER        0
#define GANGLE         1
#define GMIDDLE_WIDTH  2
#define GMIDDLE_HEIGHT 3


/*
 * alignment types definition
 */
#define GON_CENTER 0
#define GON_BORDER 1


/*
 * orientation definition for GoBusLink
 */
#define GHORIZONTAL 0    /*
			              |
			    ----------
			   |
			 */

#define GVERTICAL   1    /*
			         --
				|
				|
				|
			      --	
			 */
#define GUNDEFINED  2



#endif /* _GoGraDef_h */
