/* $Id: ItorPgm.h,v 1.1 1992/12/10 15:37:42 jojic Exp $ */
/*****************************************************************************
MODULE:  Go Kernel (User Interface)
FILE:    ItorPgm.h
AUTHOR:  Oliver Jojic
DATE:    June 92

DESCRIPTION:

COPYRIGHT:
  Copyright (c) 1990, 1991, 1992 Bull S.A., Paris, France
 
  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull.
  
  The permission to distribute or sublicense FOR CHARGE either this software
  (all or part) or products derived from this software is subject to prior
  licence from Bull under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull.

  Bull assumes no responsibility for the use or inability to use any of its
  software. The software is provided "AS IS" without warranty of any
  kind, and Bull expressly disclaims all implied warranties, including
  but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull be liable for any special, incidental, indirect
  or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.

*****************************************************************************/
#ifndef _ItorPgm_h
#define _ItorPgm_h

#include <Go/Interactor.h>


class GInteractorPgm
{
  public:
    
    static const char* type(); // returns the type uses when a Binding time;

    friend GInteractorPgm*
	GInteractorPgmFromName (const char* interaction_program_name);

    const char* name () const {	return _name; }

    int   cursorIdent() { return _cursorIdent; }
    void  cursorIdent(int cid) { _cursorIdent = cid;}

    virtual GInteractor* start (const GEvent*, Go*) = 0;
    virtual GEventMask inputMask () const = 0;
    virtual ~GInteractorPgm ();

  protected:

    GInteractorPgm (const char* name);
    void Initialize (GInteractor* itor) const { itor->Initialize(); }

  private:

    /* private data */
    const char* _name;
    int         _cursorIdent;
};

#endif /* _ItorPgm_h */
