/* $Id: SimpleForm.h,v 1.4 1992/11/12 15:37:57 andre Exp $ */
/*****************************************************************************
MODULE:  GoText
FILE:    SimpleForm.h
AUTHOR:  Michel Andre
DATE:    August 91
 

COPYRIGHT:
  Copyright (c) 1990, 1991 Bull S.A., Paris, France

  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull.

  The permission to distribute or sublicense FOR CHARGE either this software
  (all or part) or products derived from this software is subject to prior
  licence from Bull under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull.

  Bull assumes no responsibility for the use or inability to use any of its
  software. The software is provided "AS IS" without warranty of any
  kind, and Bull expressly disclaims all implied warranties, including
  but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull be liable for any special, incidental, indirect
  or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.
*****************************************************************************/

#ifndef         _S_Form_h
#define         _S_Form_h

#include <Go/Form.h>

class GSimpleFormatterCtxt: public GFormatterCtxt
{
public:
friend class	GSimpleFormatter;
};


class GSimpleFormatter : public GFormatter{

public:
			GSimpleFormatter();
const  char*		getClassname() const;
static const char*	classname();
static int 		restore (GSimpleFormatter**, GoStream*);
static void		init();
       void	        reframe() {if (_enableReframe) organize (NULL, NULL);}

protected:
    void	setString();
    void	insertChar (char, GPos);
    void	insertString (const char*, GPos, GPos);
    void	deleteChar (char, GPos);
    void	deleteString (const char*, GPos, GPos);
    void	replaceChar (char, GPos);
    void	replaceString (GPos, GPos, char*, GPos);
    static int 	readParams (GSimpleFormatter*, GoStream*);
    GFormatter*	dup();
    GPoint	lineOrigin (GoTextLine*) const;
    void	assembly (GoTextSegment*, GoTextSegment*);
    void        organize (Go* = NULL, Go* = NULL);
};

#endif		/* _S_Form_h */
