/* $Id: TextList.h,v 1.1 1992/08/06 11:50:06 uep Exp $ */
/*****************************************************************************
MODULE:  Textual
FILE:    TextList.h
AUTHOR:  Michel Andre
DATE:    1/7/92

DESCRIPTION: The TextList is a list of which cell contains a couple
         of positions.
    

COPYRIGHT:
  Copyright (c) 1990, 1991 Bull S.A., Paris, France

  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull.

  The permission to distribute or sublicense FOR CHARGE either this software
  (all or part) or products derived from this software is subject to prior
  licence from Bull under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull.

  Bull assumes no responsibility for the use or inability to use any of its
  software. The software is provided "AS IS" without warranty of any
  kind, and Bull expressly disclaims all implied warranties, including
  but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull be liable for any special, incidental, indirect
  or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.
******************************************************************************/
#ifndef _TextList_h
#define _TextList_h


#include <Go/TextDefs.h>


class GTextSeg
{
public:
    		GTextSeg();
    GBool	contains (GTextSeg&) const;
    GBool	contains (GPos) const;
    void	shift (GPos, GPos);
    void	deletePortion (GPos, GPos);
    GPos	first() const {return _first;}
    void	first (GPos);
    GPos	last() const {return _last;}
    void	last (GPos);
    GTextSeg*	next() const {return _next;}

private:
    GPos	_first;
    GPos	_last;
    GTextSeg*	_next;

friend class GTextList;
};


class GTextList
{
public:
		GTextList();
		~GTextList();

    void	insertSeg (GTextSeg*);
    void	deleteSeg (GTextSeg*);
    void	deletePortion (GPos, GPos);
    void	shift (GPos, GPos);
    void	reinit();
    int		size() const {return _size;}
    GTextSeg*	first() const {return _first;}
    GBool	contains (GPos) const;
    GTextSeg*	posToSeg (GPos) const;

private:
    int		_size;
    GTextSeg*	_first;
};


#endif /*_TextList_h */
