/* $Id: TextLn.h,v 1.9 1992/12/11 08:35:23 jojic Exp $ */
/*****************************************************************************
MODULE:  GoText
FILE:    TextLn.h
AUTHOR:  Michel Andre
DATE:    August 91
 
COPYRIGHT:
  Copyright (c) 1990, 1991 Bull S.A., Paris, France

  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull.

  The permission to distribute or sublicense FOR CHARGE either this software
  (all or part) or products derived from this software is subject to prior
  licence from Bull under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull.

  Bull assumes no responsibility for the use or inability to use any of its
  software. The software is provided "AS IS" without warranty of any
  kind, and Bull expressly disclaims all implied warranties, including
  but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull be liable for any special, incidental, indirect
  or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.
*****************************************************************************/

#ifndef		_TextLn_h
#define		_TextLn_h

#include	<Go/TextSg.h>

class GoTextLine: public Go
{
  public:
    static GoMetaclass* metaclass();
    static GoTextLine*	create();

    static int          save (const GoTextLine*, GoStream*);    
    static int          restore (GoTextLine**, GoStream*);

  protected:
    virtual void	m_dup(const Go*, Go*, Go*, GBool, GBool);

  private:
    GoMetaclass*	m_metaclass() const;
			GoTextLine();
    GoTextLine*		NextLine();
    GoTextLine*		PreviousLine();
    void		organize (GNumber width = 0);

    virtual GAssoc*      d_get_assoc() const {return NULL;}
    virtual Go*          d_get_parent() const {return _parent;}
    virtual Go*          d_get_previous() const;
    virtual Go*          d_get_next() const {return _next;}
    virtual Go*          d_get_first_child() const {return _child;}
    virtual GBool        d_store_children_array() const {return GFALSE;}
    virtual void         d_set_previous (const Go*){}
    virtual void         d_set_next (const Go* go) {_next = (Go*)go;}
    virtual void         d_remove_child (const Go*, int);
    virtual void         d_add_child (const Go*, int);
    virtual void         d_set_tree (const Go*, const Go*, const Go*);
    virtual GBool        d_store_abscs() const {return GFALSE;}
    virtual GBool        d_store_relcs() const {return GTRUE;}
    virtual const GCoordSys& d_get_relcs (const GCoordSys*) const;
    virtual void         d_set_coordsys (const GCoordSys& relcs, const GCoordSys&,
                             const GCoordSys&) {_origin = relcs.O;}
    virtual GRegion*     d_get_clip() const;

    /*** data ***/
    GNumber		_width;
    GNumber		_height;
    Go* 		_parent;
    Go* 		_next;
    Go* 		_child;
    GPoint		_origin;
    GRegion             _clip;    

    friend class	GoTextSegment;
    friend class	GoText;
    friend class	GFormatter;
    friend class	GSimpleFormatter;
    friend class	GFrFormatter;
    friend class	GMCFormatter;
    friend class	GMBFormatter;
    friend class	GCircleFormatter;
    friend class	GFrFormatterCtxt;
    friend class	GMCFormatterCtxt;
    friend class	GMBFormatterCtxt;
    friend class	GCircleFormatterCtxt;
    friend class	GoTextLineMetaclass;
};

INLINE GoTextLine* GoTextLine::create() {
    return (GoTextLine*) Go::Create(GoTextLine::metaclass());
}

#endif			/* _TextLn_h */
