/* $Id: Bind.h,v 1.2 1992/12/10 13:54:05 jojic Exp $ */
/*****************************************************************************
MODULE: Go Tools
FILE:   Bind.h
AUTHOR: jojic
DATE:   Jun 29 1992

DESCRIPTION :

  BThe GBind function allows to set or to get a pointer to/from a string.
  The call of:
	GBind(string, pointer)

  will set the value ``pointer'' to the name ``string'';
  and the call of:
	GBind(string)

  will return ``pointer''.

  This function is particularly used by some interactors which allow the
  definition of user interactions inside ascii files. These files contain some
  function names. Interactors use ``GBind'' to retreive the function pointer
  associated to this name. This implies that if you want to add some of yours
  function names inside one of these files, you have to set their associated
  function pointers using ``GBind''.

  In the Go World, all objects that want to make such an association use
  ``GBind''.
  
COPYRIGHT :    
  Copyright (c) 1992 Bull S.A.
 
  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull S.A. may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull S.A..
  
  The permission to distribute or sublicense FOR CHARGE either this software
  (all or part) or products derived from this software is subject to prior
  licence from Bull S.A. under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull S.A..

  Bull S.A. assumes no responsibility for the use or inability to use
  any of its software. The software is provided "AS IS" without warranty
  of any kind, and Bull S.A. expressly disclaims all implied warranties,
  including but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull S.A. be liable for any special, incidental,
  indirect or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.
*****************************************************************************/
#ifndef _Bind_h
#define _Bind_h

#include <Go/machdef.h>
#include <Go/Tools/Bool.h>


void GBind (const char* name, void* value, const char* type = NULL);

GBool GBinded (const char* name,
	       void*& value = NULLREF,
	       const char*& type = (const char*&)NULLREF);

void GRemoveBinding (const char* name);

#endif /* _Bind_h */
