/* $Id: mGeometric.h,v 1.1.1.1 1992/03/18 10:06:35 uep Exp $ */
/*****************************************************************************
MODULE:  Graphic Objects
FILE:    mGeometric.h
AUTHOR:  Gilles Benati
DATE:    Feb 1991

DESCRIPTION:

  See the Geometric.h header.
    
COPYRIGHT:
  Copyright (c) 1990, 1991 Bull S.A., Paris, France
 
  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull.
  
  The permission to distribute or sublicense FOR CHARGE either this software
  (all or part) or products derived from this software is subject to prior
  licence from Bull under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull.

  Bull assumes no responsibility for the use or inability to use any of its
  software. The software is provided "AS IS" without warranty of any
  kind, and Bull expressly disclaims all implied warranties, including
  but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull be liable for any special, incidental, indirect
  or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.
*****************************************************************************/
#ifndef _mGoGeometric_h
#define _mGoGeometric_h

#include <Go/mGoStdDS.h>

extern GActionRec empty_action_array[];

class GoGeometricMetaclass : public GoStdDSMetaclass {
    friend class GoGeometric;
	
  public:

    void outlinePrecond(GBool func(void*, const GoGeometric*, GBool*),
			void* closure, GAddOrRemove = GADD);
    void outlinePostcond(void func(void*, GoGeometric*),
			 void* closure, GAddOrRemove = GADD);
    void backgroundPrecond(GBool func(void*, const GoGeometric*, GBool*),
			   void* closure, GAddOrRemove = GADD);
    void backgroundPostcond(void func(void*, GoGeometric*),
			    void* closure, GAddOrRemove = GADD);

  protected:

    GoGeometricMetaclass();
    virtual ~GoGeometricMetaclass();

  private:

    GBool _has_outline_precond     :1;
    GBool _has_outline_postcond    :1;
    GBool _has_background_precond  :1;
    GBool _has_background_postcond :1;

    virtual const char*      m_classname() const;
    virtual GoMetaclass*     m_superclass() const;
    virtual const GActionRec* m_actions () const;
//  virtual Go*              m_create() const;
};

#endif /* _mGoGeometric_h */
