/* $Id: mImage.h,v 1.1.1.1 1992/03/18 10:07:39 uep Exp $ */
/***************************************************************************** 
MODULE: Graphic Objects
FILE:   mImage.h
AUTHOR: Oliver Jojic
DATE:   Feb 1991

DESCRIPTION :

  GoImage Metaclass Description

COPYRIGHT:
  Copyright (c) 1990, 1991 Bull S.A., Paris, France
 
  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull.
  
  The permission to distribute or sublicense FOR CHARGE either this software
  (all or part) or products derived from this software is subject to prior
  licence from Bull under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull.

  Bull assumes no responsibility for the use or inability to use any of its
  software. The software is provided "AS IS" without warranty of any
  kind, and Bull expressly disclaims all implied warranties, including
  but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull be liable for any special, incidental, indirect
  or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.
*****************************************************************************/
#ifndef _mGoImage_h
#define _mGoImage_h

#include <Go/mGoStdDS.h>

class GoImageMetaclass : public GoStdDSMetaclass {
    friend class GoImage;

  public:

    void configPrecond(GBool func(void*, const GoImage*, GNumber*, GNumber*, GPoint*),
		      void* closure, GAddOrRemove = GADD);
    void configPostcond(void func(void*, GoImage*),
			void* closure, GAddOrRemove = GADD);

  protected:
    
    GoImageMetaclass();
    virtual ~GoImageMetaclass();

  private:

    // pre/post condition flags;

    GBool _has_config_precond   :1;
    GBool _has_config_postcond  :1;

    // pre/post conditions;

    GBool call_config_precond(const GoImage*, GNumber*, GNumber*, GPoint*) const;
    void call_config_postcond(GoImage*) ;

    virtual const char*       m_classname() const;
    virtual GoMetaclass*      m_superclass() const;
    virtual const GActionRec* m_actions () const;
    virtual Go*               m_create() const;
};


#endif /* _mGoImage_h */


