/* $Id: pcdef.h,v 1.2 1992/11/25 16:04:37 smadja Exp $ */
/****************************************************************************
         Copyright BULL-SA 1990
MODULE:  Machine Dependent
FILE:    pcdef.h
AUTHOR:  Yuanzhang Song
DATE:    21 October 1990

DESCRIPTION:
  Machine Dependent definitions with 1): DOS 3.30
											    2): Glockenspiel C++ 2.0c
												 3): Microsoft C 6.0
                                     4): Borland C++ 3.0
	
COPYRIGHT:
  Copyright (c) 1990, 1991 Bull S.A., Paris, France
 
  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull.
  
  The permission to distribute or sublicense FOR CHARGE either this software
  (all or part) or products derived from this software is subject to prior
  licence from Bull under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull.

  Bull assumes no responsibility for the use or inability to use any of its
  software. The software is provided "AS IS" without warranty of any
  kind, and Bull expressly disclaims all implied warranties, including
  but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull be liable for any special, incidental, indirect
  or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.
*****************************************************************************/
#ifdef GLOKENSPIEL
#include <stream.h>
#include <strstrm.hxx>
#include <new.hxx>
#include <math.h>
#include <float.h>
#include <errno.h>
#define WINDOWS_int_16b
#define NO_ALLOCA
#define  STATIC_OBJECT(type, variable) \
		static type* p_##variable; \
		if(p_##variable == NULL) \
			p_##variable = new type;\
		type& variable = *p_##variable

extern "C" {
#include "c:\c600\include\malloc.h"
#include "c:\c600\include\stdlib.h"
#include <string.h>
}
#else

#ifdef __BORLANDC__
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <float.h>
#include <math.h>
#ifndef PI
#define PI M_PI
#endif
#define WINDOWS_int_16b
#define _cs __cs
#ifdef __DLL__
#define NO_ALLOCA
#define  STATIC_OBJECT(type, variable) \
		static type* p_##variable; \
		if(p_##variable == NULL) \
			p_##variable = new type;\
		type& variable = *p_##variable

#endif

#else

#ifndef __MSC7__
#define __MSC7__
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <float.h>
#include <math.h>
#ifndef M_PI
#define M_PI        3.14159265358979323846
#endif
#ifndef PI
#define PI M_PI
#endif
#define WINDOWS_int_16b
#define _cs __cs
#define NO_ALLOCA
#define  STATIC_OBJECT(type, variable) \
		static type* p_##variable; \
		if(p_##variable == NULL) \
			p_##variable = new type;\
		type& variable = *p_##variable

#endif
#endif


#ifndef GLOKENSPIEL

#include "builtin.h"


#ifndef __GNUC__
inline float max (float a, float b)
{
    return (a > b) ? a : b;
}
#endif

inline float max (float a, float b, float c)
{
    return (a > b) ? max(a, c) : max(b, c);
}

inline float max (float a, float b, float c, float d)
{
    return (a > b) ? max(a, c, d) : max(b, c, d);
}

#ifndef __GNUC__
inline float min (float a, float b)
{
    return (a < b) ? a : b;
}
#endif

inline float min (float a, float b, float c)
{
    return (a < b) ? min(a, c) : min(b, c);
}

inline float min (float a, float b, float c, float d)
{
    return (a < b) ? min(a, c, d) : min(b, c, d);
}


#ifndef __GNUC__
inline long max (long a, long b)
{
    return (a > b) ? a : b;
}
#endif

inline long max (long a, long b, long c)
{
    return (a > b) ? max(a, c) : max(b, c);
}

inline long max (long a, long b, long c, long d)
{
    return (a > b) ? max(a, c, d) : max(b, c, d);
}

#ifndef __GNUC__
inline long min (long a, long b)
{
    return (a < b) ? a : b;
}
#endif

inline long min (long a, long b, long c)
{
    return (a < b) ? min(a, c) : min(b, c);
}

inline long min (long a, long b, long c, long d)
{
    return (a < b) ? min(a, c, d) : min(b, c, d);
}

#endif 

#ifndef HAVE_VPRINTF
#define HAVE_VPRINTF
#endif


#define INLINE inline
		
#ifndef INLINE_NO_RETURN
#define INLINE_NO_RETURN
#endif

#ifndef STATIC_CONFUSION
#define STATIC_CONFUSION
#endif

#define ArraySize(array) (sizeof(array) / sizeof(array[0]))

typedef unsigned short ushort;
typedef unsigned char uchar;
typedef unsigned int uint;
typedef unsigned long ulong;

#ifndef NULL
#define NULL 0
#endif

#ifdef append
#undef append
#endif

inline void bcopy(const void *src, void *dest, long size)
{
	memmove( dest, src, (short) size );
}

inline short bcmp(void *src, void *dest, long size)
{
	return (short) memcmp( src, dest, (size_t) size  );
}

inline void * bzero( void * dest, long size)
{
    return memset(dest, 0, (size_t) size);
}

#ifndef MAXFLOAT
#define MAXFLOAT 	1.0e+20 	/* max value */
#endif

#ifndef MINFLOAT
#define MINFLOAT 	-MAXFLOAT
#endif


#ifndef MAXSHORT
#define MAXSHORT 	32767 	/* max value */
#endif

#ifdef __BORLANDC__
#include <dos.h>
#define argc _argc
#define argv _argv 
#else
#ifdef __MSC7__
extern "C" {
extern unsigned int  _hInstance;
extern unsigned int _hPrevInstance;
extern char *		  _lpszCmdLine;
extern int			  _cmdShow;
extern int			  __argc;
extern char**		  __argv;
} 
#define argc __argc
#define argv __argv 
#endif
#endif
