#ifdef REV_INFO
static char rcsid[] = "$Id: EdEllipse.cc,v 1.1 1992/12/30 15:57:29 smadja Exp $";
#endif
/*****************************************************************************
MODULE:  Go Kernel (User Interface)
FILE:    EdEllipse.cc
AUTHOR:  Philippe Smadja/Gilles Benati
DATE:    June 92

DESCRIPTION:
  See the EdEllipse.h header.
  program name: "GoEllipse.edit"
  
COPYRIGHT:
  Copyright (c) 1990, 1991, 1992 Bull S.A., Paris, France
 
  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull.
  
  The permission to distribute or sublicense FOR CHARGE either this software
  (all or part) or products derived from this software is subject to prior
  licence from Bull under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull.

  Bull assumes no responsibility for the use or inability to use any of its
  software. The software is provided "AS IS" without warranty of any
  kind, and Bull expressly disclaims all implied warranties, including
  but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull be liable for any special, incidental, indirect
  or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.

*****************************************************************************/

#include <Go/EdEllipse.h>
#include <Go/Ellipse.h>
#include <Go/Tools/Error.h>
#include <Go/Tools/Bind.h>
#include <stdio.h>

/*
 * PROGRAM
 *********
 */

// EDIT PROGRAM;
// The interactor will be the arc one;

GEditEllipsePgm* GEditEllipsePgm::create ()
{
    void* value;
    const char* type;
    char  editEllipseName[128];

    sprintf (editEllipseName, "%s.edit",
	   GoEllipse::metaclass()->classname());

    if (GBinded (editEllipseName, value, type))
    {
	if (type != GInteractorPgm::type())
	{
	    GWarning ("GEditEllipsePgm::create: the name \"%s\" is already used as a \"%s\" type.",
		      editEllipseName, (type == NULL) ? "(NULL)" : type);
	    return NULL;
	}

	return (GEditEllipsePgm*) value;
    }

    return new GEditEllipsePgm (editEllipseName);
}

