/* $Id: PSPrivate.h,v 1.2 1992/07/17 12:00:02 smadja Exp $ */
/*****************************************************************************
MODULE:  GoInterface
FILE:    PSPrivate.h
AUTHOR:  Philippe Smadja.
DATE:    Jul 1991

DESCRIPTION:
  Definitions of private type and defaine for PSGoInterf.

COPYRIGHT:
  Copyright (c) 1990, 1991 Bull S.A., Paris, France
 
  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull.
  
  The permission to distribute or sublicense FOR CHARGE either this software
  (all or part) or products derived from this software is subject to prior
  licence from Bull under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull.

  Bull assumes no responsibility for the use or inability to use any of its
  software. The software is provided "AS IS" without warranty of any
  kind, and Bull expressly disclaims all implied warranties, including
  but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull be liable for any special, incidental, indirect
  or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.
******************************************************************************/

#define PS_PATH              "ps"
#define FONT_PATH            "ps/fonts"
#define METRIC_DATA_BASE     "ALIASES"      /* the path is $(FONT_PATH)/ALIASES */
#define PROLOGUE_FILE        "prologue.ps"  /* the path is $(PS_PATH)/....ps  */
#define IMAGE_FILE           "image.ps"

#define LINE_SZ 256    /* a line of the generated programm */

/**
  method names to generate
  the name with @ are defined in the prologue:
  the prologue is loaded at the beginning of the medium.
  **/
#define SCALE         "@sc"
#define TRANSLATE     "@tr"
#define SETGRAY       "@sg"
#define SETRGBCOLOR   "@rgb"
#define SETLINEWIDTH  "@lw"
#define SETLINEJOIN   "@lj"
#define SETLINECAP    "@lc"
#define SETMITERLIMIT "@ml"
#define SETDASH       "@sd"
#define GSAVE         "@gs"
#define GRESTORE      "@gr"
#define FILL          "@fi"
#define EOFILL        "@eo"
#define STROKE        "@st"
#define MOVETO        "@mv"
#define RMOVETO       "@rm"
#define LINETO        "@ln"
#define NEWPATH       "@np"
#define CLOSEPATH     "@cl"
#define SHOWPAGE      "@sp"
#define RECTANGLE     "@rect"
#define MOVETOSHOW    "@ms"
#define SHOW          "@sh"
#define SETFONT       "@sf"
#define MAKESETFONT   "@mks"
#define FINDFONT      "@ff"
#define ENCODEDEFINEFONT "@edf"
#define INIT          "@ini"
#define CMAPIMAGE     "@cm_ima"
#define CMAP_CURRENTFILE_IMAGE     "@cm_cf_ima"
#define UNDEFINE      "@ud"
#define ELLIPSE       "@ell"
#define ELLIPSE_CHORD "@elc"
#define ELLIPSE_PIE   "@elp"
#define CONCAT        "concat"
#define IMAGE         "image"
#define END_OF_PROGRAM "%%EOF"

