/* $Id: XRegionP.h,v 1.2 1992/09/25 15:26:11 smadja Exp $ */
/*****************************************************************************
MODULE:  XGoInterface
FILE:    XregionP.h
AUTHOR:  Philippe Smadja
DATE:    Jan 1991

DESCRIPTION:
         ShXRegion are shared object. The matches criterium is
	 1: the coordsys (values are in pixels).

COPYRIGHT :
  Copyright (c) 1990, 1991 Bull S.A., Paris, France
 
  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull.
  
  The permission to distribute or sublicense FOR CHARGE either this software
  (all or part) or products derived from this software is subject to prior
  licence from Bull under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull.

  Bull assumes no responsibility for the use or inability to use any of its
  software. The software is provided "AS IS" without warranty of any
  kind, and Bull expressly disclaims all implied warranties, including
  but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull be liable for any special, incidental, indirect
  or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.
*****************************************************************************/
#ifndef _XRegionP_h
#define _XRegionP_h

#include <X11/Xlib.h>
#include <X11/Xutil.h>

#include <Go/Tools/Assoc.h>
#include <Go/Tools/CoordSys.h>
#include <Go/Tools/SharedObj.h>

#define SHXREGIONMASK (ulong)-1

struct ShXRegionValues
{
    const GCoordSys*  cs;
} ;

class ShXRegion : public GSharedObject {
  private:
    
    static GList* _headOfList;
    static GFunctionList _funcList;

    GCoordSys    _cs;
    ushort       _width;
    ushort       _height;

    Region       _xregion;

    void         _makeRegion();

  protected:
    
    GList*& _head();
    int     _valueSize ();
    virtual GBool   _match (ulong mask, const void* values) const;
    virtual void    _makeNewValues (ulong mask, const void* values,
				    ulong& newMask, void* newValues) const;
    virtual ulong   _update (ulong mask, const void* values);
    
    friend ShXRegion* _newShXRegion (GFunctionList* funcList,
				     ulong mask,
				     const void* values,
				     const char* name = NULL);

    ShXRegion (GFunctionList* funcList, ulong mask,
	       const ShXRegionValues* values, const char* name = NULL);
    ~ShXRegion ();

  public:
    inline ShXRegion* dup() const { return (ShXRegion*) ((GSharedObject*)this)->dup();}
    inline const struct _XRegion* region() const { return  _xregion; }
    inline const GCoordSys* cs() { return &_cs ; }
    inline width()   { return _width; } ;
    inline height()  { return _height; } ;

    friend  ShXRegion* GCreateShXRegion (const GCoordSys& cs);
};


#endif /* _XRegion_h */




