/* $Id: GraphicP.h,v 1.1.1.1 1992/03/18 10:33:49 uep Exp $ */
/*****************************************************************************
MODULE:  Bull Widget Set
FILE:    GraphicP.h
AUTHOR:  Patricia Langle
DATE:    29 May 1990

DESCRIPTION:
    Private header file for the Graphic Widget

COPYRIGHT:
  Copyright (c) 1990, 1991 Bull S.A., Paris, France

  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull.

  The permission to distribute or sublicense FOR CHARGE either this software
  (all or part) or products derived from this software is subject to prior
  license from Bull under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull.

  Bull assumes no responsibility for the use or inability to use any of its
  software. The software is provided "AS IS" without warranty of any
  kind, and Bull expressly disclaims all implied warranties, including
  but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull be liable for any special, incidental, indirect
  or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.
******************************************************************************/
    
#ifndef _XbGraphicP_h
#define _XbGraphicP_h

#include <Xb/Graphic.h>
#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <X11/Xutil.h>
#include <Xm/Xm.h>
#include <Xm/XmP.h>
#include <Xm/DrawingAP.h>
#include <Xm/BulletinBP.h>
#include "cGoGraphic.h"


typedef struct {
     int mumble;   /* No new procedures */
} XbGraphicClassPart;

/****************
 *
 * Class record declaration
 *
 ****************/
typedef struct _XbGraphicClassRec {
    CoreClassPart		core_class;
    CompositeClassPart  	composite_class;
    ConstraintClassPart 	constraint_class;
    XmManagerClassPart  	manager_class;
    XmDrawingAreaClassPart      drawing_area_class;
    XbGraphicClassPart		graphic_class;
} XbGraphicClassRec;

extern XbGraphicClassRec xbGraphicClassRec;

/****************
 *
 * Graphic Widget instance structure.
 *
 ****************/
typedef struct {

/* private */
   XmGoInterf* gointerf;
   GoRoot*     goroot;
   Dimension   old_width;
   Dimension   old_height;

/* resources */
   Boolean editable;
   Boolean scale_on_resize;
   Boolean auto_resize;
   
} XbGraphicPart;


/************************************************************************
 *									*
 * Full instance record declaration					*
 *									*
 ************************************************************************/

typedef struct _XbGraphicRec {
    CorePart	        core;
    CompositePart       composite;
    ConstraintPart      constraint;
    XmManagerPart       manager;
    XmDrawingAreaPart   drawing_area;
    XbGraphicPart       graphic;
} XbGraphicRec;

#endif /* _XbGraphicP_h */
