/* $Id: cGoGraphic.h,v 1.2 1992/07/22 07:37:00 smadja Exp $ */
/*****************************************************************************
MODULE:  Xm Go Interface
FILE:    cGoGraphic.h
AUTHOR:  Jacques Davy
DATE:    February 1991

DESCRIPTION:
    This file gives the C Binding Interface needed to use Go (Version 1.0)
    from the Graphic Widget (Graphic.c). It could use the Go C interface.

COPYRIGHT:
  Copyright (c) 1990, 1991 Bull S.A., Paris, France

  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull.

  The permission to distribute or sublicense FOR CHARGE either this software
  (all or part) or products derived from this software is subject to prior
  license from Bull under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull.

  Bull assumes no responsibility for the use or inability to use any of its
  software. The software is provided "AS IS" without warranty of any
  kind, and Bull expressly disclaims all implied warranties, including
  but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull be liable for any special, incidental, indirect
  or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.
******************************************************************************/

#ifndef _XbGoInterf_h
#define _XbGoInterf_h

#include <Go/cmachdef.h>

typedef void  Go;
typedef void  GoInterf;
typedef void  XmGoInterf;
typedef void  GoRoot;
typedef float GNumber;

typedef enum { GREMOVE, GADD } GAddOrRemove;

#ifndef _NO_PROTO

XmGoInterf* XmGoInterf_new(Widget);

void XmGoInterf_delete    (XmGoInterf* gointerf);

void XmGoInterf_map       (XmGoInterf* gointerf);
void XmGoInterf_unmap     (XmGoInterf* gointerf);

void XmGoInterf_resize    (XmGoInterf* gointerf,
			   int new_width_in_pixels,
			   int new_height_in_pixels);

void XmGoInterf_setBackground (XmGoInterf* gointerf, ulong pixel);

void XmGoInterf_handle    (XmGoInterf* gointerf, XEvent* event);

/* GoRoot management */
XmGoInterf* GoRoot_interf  (GoRoot* goroot);
void        GoRoot_flush   (GoRoot* goroot);
void        GoRoot_rescale (GoRoot* goroot, int w_per_cent, int h_per_cent);
int         GoRoot_width   (GoRoot* goroot);
int         GoRoot_height  (GoRoot* goroot);
void        GoRootClass_interfPostcond
                           (void (*proc)(void*, Go*, GoInterf* old_interf),
			    void* closure, GAddOrRemove add);
void GoRoot_resizePostcond (GoRoot* goroot, void (*proc)(void*, Go*),
			    void* closure, GAddOrRemove add);
void GoRoot_destroyPostcond(GoRoot* goroot, void (*proc)(void*, Go*),
			    void* closure, GAddOrRemove add);

#else /* _NO_PROTO */

/* GoInterf Management */
XmGoInterf* XmGoInterf_new();
void        XmGoInterf_delete();
void        XmGoInterf_map();
void        XmGoInterf_unmap();
void        XmGoInterf_resize();
void        XmGoInterf_handle();
void        XmGoInterf_setBackground();

/* GoRoot management */
XmGoInterf* GoRoot_interf();
void        GoRoot_flush();
void        GoRoot_rescale();
int         GoRoot_width();
int         GoRoot_height();
void        GoRootClass_interfPostcond();
void        GoRoot_resizePostcond();
void        GoRoot_destroyPostcond();

#endif /* _NO_PROTO */

#endif  /* _XbGoInterf_h */
