#ifdef REV_INFO
static char rcsid[] = "$Id: XtGoInterf.cc,v 1.3 1992/12/10 14:05:15 jojic Exp $";
#endif
/*****************************************************************************
MODULE:  Xt INTERFACE
FILE:    XtGoInterf.cc
AUTHOR:  Philippe Smadja
DATE:    April 91

DESCRIPTION:
    The Xt Window System interface for Go.
    No implementation is needed; we compile only the header file.
    
COPYRIGHT:
  Copyright (c) 1990, 1991 Bull S.A., Paris, France
 
  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull.
  
  The permission to distribute or sublicense FOR CHARGE either this software
  (all or part) or products derived from this software is subject to prior
  licence from Bull under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull.

  Bull assumes no responsibility for the use or inability to use any of its
  software. The software is provided "AS IS" without warranty of any
  kind, and Bull expressly disclaims all implied warranties, including
  but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull be liable for any special, incidental, indirect
  or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.
******************************************************************************/

#include <Go/XtGoInterf.h>

/**
FUNCTION
    widget
DESCRIPTION
    returns the widget  associated to by the drawable.
    Ask the toolkit to retreive it.
**/

Widget XtGoInterf::widget()
{
    if (_isWindow)
	return XtWindowToWidget(_dpy, _drawable);
    return NULL;
}


void xgointerf_handle (void*, void* closure, XEvent* xevent)
{
    XGoInterf* xinterf = (XGoInterf*) closure;
    xinterf->handleXEvent(xevent);
}    


void XtGoInterf::addInputMask (GEventMask mask)
{
    if (_xinputMask != 0)
	XtRemoveEventHandler
	    (widget(), (ulong)(_xinputMask & ~PointerMotionHintMask),
	     False, (XtEventHandler)xgointerf_handle, (XtPointer)this);

    GoInterf::addInputMask (mask);
    _xinputMask  = GEventMaskToXEventMask(inputMask());
    if (_xinputMask != 0)
	XtAddEventHandler
	    (widget(), (ulong)(_xinputMask & ~PointerMotionHintMask),
	     False, (XtEventHandler)xgointerf_handle, (XtPointer)this);
}

void XtGoInterf::removeInputMask (GEventMask mask)
{
    if (_xinputMask != 0)
	XtRemoveEventHandler
	    (widget(), (ulong)(_xinputMask & ~PointerMotionHintMask),
	     False, (XtEventHandler)xgointerf_handle, (XtPointer)this);

    GoInterf::removeInputMask (mask);
    _xinputMask  = GEventMaskToXEventMask(inputMask());
    if (_xinputMask != 0)
	XtAddEventHandler
	    (widget(), (ulong)(_xinputMask & ~PointerMotionHintMask),
	     False, (XtEventHandler)xgointerf_handle, (XtPointer)this);
}
