#ifdef REV_INFO
static char rcsid[] = "$Id: List.cc,v 1.2 1992/09/25 14:31:51 smadja Exp $";
#endif
/*****************************************************************************
MODULE:  Tools
FILE:    List.cc
AUTHOR:  Philippe Smadja
DATE:    04/27/89

DESCRIPTION:
    See <Go/Tools/List.h>

COPYRIGHT:
  Copyright (c) 1990, 1991 Bull S.A., Paris, France
 
  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull.
  
  The permission to distribute or sublicense FOR CHARGE either this software
  (all or part) or products derived from this software is subject to prior
  licence from Bull under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull.

  Bull assumes no responsibility for the use or inability to use any of its
  software. The software is provided "AS IS" without warranty of any
  kind, and Bull expressly disclaims all implied warranties, including
  but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull be liable for any special, incidental, indirect
  or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.
******************************************************************************/

#include <Go/Tools/List.h>

/**
FUNCTION
    contructor( GList*& head).
DESCRIPTION
    The constructor puts the new object to the beginning of the list.
    Note that there is no destructor of the list. see remove().
**/
GList::GList ( GList*& head ) 
{
	tobegin(head) ;
}

/**
FUNCTION
    tobegin( GList*& head).
DESCRIPTION
    This function puts the object to the begnning of the list.
    Note that there is no destructor of the list. see remove().
**/

void
GList::tobegin(GList*& head) const
{
	((GList*)this)->_next = head ; head = (GList*)this ;
}
	
/**
FUNCTION
    remove(GList*& head) 
DESCRIPTION
    we remove the object from the list.
	the caller MUST delete the object after the remove().
**/
void
GList::remove ( GList*& head ) 
{
	if ( this == head ) {
		head = head->_next ;
	} else  {
		GList* list ;
		for ( list = head ; ; list = list->_next )
			if ( list->_next == this ) {
				list->_next = this->next() ;
				break ;
			}
	}
}

/**
FUNCTION
    raise(GList*& head).
DESCRIPTION
    put the object to the top of the list
**/
void
GList::raise ( GList*& head ) const
{
	if ( this == head )
		return ;
	GList* list ;
	for ( list = head ; ; list = list->_next )
		if ( list->_next == this ) {
			list->_next = this->next() ;
			break ;
		}
	((GList*)this)->_next = head ;
	head = (GList*)this ;
}



void
GList::toend ( GList*& head ) const
{
	if ( this->next() == NULL )	/* this is already the end */
		return ;

	GList* list ;

	if ( head == this ) {
		head = this->next() ;
	} else for ( list = head; ; list = list->next() )
		if ( list->next() == this ) {
			list->_next = this->next() ;
			break ;
		}
	GList* next ;
	for ( list = (GList*)this;  (next = list->_next) != NULL ; list = next ) ;
	/* here next is NULL */
	list->_next = (GList*)this ;
	((GList*)this)->_next = NULL ;
}

