#ifdef REV_INFO
static char rcsid[] = "$Id: LengthUnit.cc,v 1.1.1.1 1992/03/18 10:52:09 uep Exp $";
#endif
/*****************************************************************************
MODULE:  Tools
FILE:    LengthUnit.cc
AUTHOR:  Song YUANZHANG
DATE:    12 October 1990

DESCRIPTION:
    The LenghtUnit object methods.

COPYRIGHT:
  Copyright (c) 1990, 1991 Bull S.A., Paris, France
 
  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull.
  
  The permission to distribute or sublicense FOR CHARGE either this software
  (all or part) or products derived from this software is subject to prior
  licence from Bull under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull.

  Bull assumes no responsibility for the use or inability to use any of its
  software. The software is provided "AS IS" without warranty of any
  kind, and Bull expressly disclaims all implied warranties, including
  but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull be liable for any special, incidental, indirect
  or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.
******************************************************************************/
#include <Go/Tools/LengthUnit.h>

float convert[5][5]= { 1.0, 1.0/0.0254, 1.0/(3.0*0.0254), 1.0/(9.0*0.0254), 1.0/(1760.0*9.0*0.0254),
		       0.0254, 1.0, 1.0/3.0, 1.0/9.0, 1.0/(1760.0*9.0),
		       0.0254*3.0, 3.0, 1.0, 1.0/3.0, 1.0/(1760*3.0),
		       0.0254*9.0, 9.0, 3.0, 1.0, 1.0/1760.0,
		       1760.0*9.0*0.0254, 1760.0*9.0, 1760.0*3.0, 1760.0, 1.0};



float GLengthUnit::to (uchar xunit, float xfactor, float value)
{
	return value * convert[xunit][_unit] * _factor / xfactor;
}

float GLengthUnit::from (uchar xunit, float xfactor, float value)
{
	return value * convert[xunit][_unit] * xfactor / _factor;
}
